/**
 * Arduino Sketch für SmartHome yourself - Arduino Lehrgang
 * 
 * Tag 4: Serieller Monitor
 * Heute bauen wir eine Ampelschaltung.
 * Dabei werden LEDs im definierten Ablauf ein/ausgeschaltet 
 * und der aktuelle Status auf dem seriellen Monitor ausgegeben.
 * 
 * https://www.arduino.cc/reference/de/language/functions/communication/serial/begin/
 * https://www.arduino.cc/reference/de/language/functions/communication/serial/print/
 * https://www.arduino.cc/reference/de/language/functions/communication/serial/println/ 
 * 
 * By Daniel Scheidler - Dezember 2019
 */

const unsigned int ROTE_LED_PIN = 3;         // globale Konstante für Pin der roten LED
const unsigned int GELBE_LED_PIN = 4;        // globale Konstante für Pin der gelben LED
const unsigned int GRUENE_LED_PIN = 5;       // globale Konstante für Pin der grünen LED

const unsigned int ROTE_LED_DELAY = 2000;    // globale Konstante für Verzögerung in Millisekunden für rote LED
const unsigned int GELB_LED_DELAY = 1000;    // globale Konstante für Verzögerung in Millisekunden für gelbe LED
const unsigned int GRUEN_LED_DELAY = 4000;   // globale Konstante für Verzögerung in Millisekunden für grüne LED

const String WARTE_STRING = "warte ";        // globale Konstante für mehrfach verwendeten String im RAM definieren
const String MS_STRING = "ms";               // globale Konstante für mehrfach verwendeten String im RAM definieren

void setup() {
  Serial.begin(38400);
  
  pinMode(ROTE_LED_PIN, OUTPUT);             // Pin für rote LED als Ausgang definieren
  pinMode(GELBE_LED_PIN, OUTPUT);            // Pin für gelbe LED als Ausgang definieren
  pinMode(GRUENE_LED_PIN, OUTPUT);           // Pin für grüne LED als Ausgang definieren

  Serial.println(F("Ampel initialisiert"));  // Serielle Ausgabe mit Zeilenumbruch
}


void loop() {
  Serial.println(F("Gruenphase"));     // Serielle Ausgabe mit Zeilenumbruch
  digitalWrite(GRUENE_LED_PIN, HIGH);  // grüne LED einschalten
  
  Serial.print(WARTE_STRING);          // Serielle Ausgabe
  Serial.print(GRUEN_LED_DELAY);       // Serielle Ausgabe
  Serial.println(MS_STRING);           // Serielle Ausgabe mit Zeilenumbruch
  
  delay(GRUEN_LED_DELAY);              // für Grün definiertes Delay abwarten


  Serial.println(F("Gelbphase"));      // Serielle Ausgabe mit Zeilenumbruch
  digitalWrite(GRUENE_LED_PIN, LOW);   // grüne LED ausschalten
  digitalWrite(GELBE_LED_PIN, HIGH);   // gelbe LED einschalten
  
  Serial.print(WARTE_STRING);          // Serielle Ausgabe
  Serial.print(GELB_LED_DELAY);        // Serielle Ausgabe
  Serial.println(MS_STRING);           // Serielle Ausgabe mit Zeilenumbruch
  
  delay(GELB_LED_DELAY);               // für Gelb definiertes Delay abwarten

  
  Serial.println(F("Rotphase"));       // Serielle Ausgabe mit Zeilenumbruch
  digitalWrite(GELBE_LED_PIN, LOW);    // gelbe LED ausschalten
  digitalWrite(ROTE_LED_PIN, HIGH);    // rote LED einschalten
    
  Serial.print(WARTE_STRING);          // Serielle Ausgabe
  Serial.print(ROTE_LED_DELAY);        // Serielle Ausgabe
  Serial.println(MS_STRING);           // Serielle Ausgabe mit Zeilenumbruch
  
  delay(ROTE_LED_DELAY);               // für rot definiertes Delay abwarten


  Serial.println(F("Rot/Gelbphase"));  // Serielle Ausgabe mit Zeilenumbruch
  digitalWrite(GELBE_LED_PIN, HIGH);   // gelbe LED einschalten
      
  Serial.print(WARTE_STRING);          // Serielle Ausgabe
  Serial.print(GELB_LED_DELAY);        // Serielle Ausgabe
  Serial.println(MS_STRING);           // Serielle Ausgabe
  
  delay(GELB_LED_DELAY);               // für gelb definiertes Delay abwarten


  Serial.println(F("Alle aus"));       // Serielle Ausgabe mit Zeilenumbruch
  digitalWrite(GELBE_LED_PIN, LOW);    // Gelbe LED ausschalten
  digitalWrite(ROTE_LED_PIN, LOW);     // Rote LED ausschalten
}
